<?php

namespace TeamBooking\WooCommerce;
defined('ABSPATH') or die('No script kiddies please!');

add_action('init', 'TeamBooking\\WooCommerce\\grip');

function grip()
{
    $args = array('post_type' => 'product');
    $products = array();
    $_pf = new \WC_Product_Factory();
    foreach (get_posts($args) as $post) {
        $products[] = $_pf->get_product($post->ID);
    }
    wp_reset_postdata();
    foreach (\TeamBooking\Functions\getSettings()->getServices() as $service) {
        foreach ($products as $product) {
            if ($product->get_attribute('tbk-service-id') === $service->getId()) continue 2;
        }
        #createProduct($service);
    }


}

function createProduct(\TeamBookingType $service)
{

    $post_id = wp_insert_post(array(
        'post_title'   => $service->getName(),
        'post_content' => $service->getServiceInfo(),
        'post_status'  => 'publish',
        'post_type'    => 'product',
    ));
    $product_attr = array(
        'tbk-service-id' => array(
            'name'         => 'tbk-service-id',
            'value'        => $service->getId(),
            'position'     => 1,
            'is_visible'   => 0,
            'is_variation' => 0,
            'is_taxonomy'  => 0
        )
    );
    wp_set_object_terms($post_id, 'simple', 'product_type');
    update_post_meta($post_id, '_visibility', 'visible');
    update_post_meta($post_id, '_stock_status', 'instock');
    update_post_meta($post_id, 'total_sales', '0');
    update_post_meta($post_id, '_downloadable', 'no');
    update_post_meta($post_id, '_virtual', 'yes');
    update_post_meta($post_id, '_regular_price', $service->getPrice());
    update_post_meta($post_id, '_sale_price', '');
    update_post_meta($post_id, '_purchase_note', '');
    update_post_meta($post_id, '_featured', 'no');
    update_post_meta($post_id, '_weight', '');
    update_post_meta($post_id, '_length', '');
    update_post_meta($post_id, '_width', '');
    update_post_meta($post_id, '_height', '');
    update_post_meta($post_id, '_sku', '');
    update_post_meta($post_id, '_product_attributes', $product_attr);
    update_post_meta($post_id, '_sale_price_dates_from', '');
    update_post_meta($post_id, '_sale_price_dates_to', '');
    update_post_meta($post_id, '_price', $service->getPrice());
    update_post_meta($post_id, '_sold_individually', '');
    update_post_meta($post_id, '_manage_stock', 'no');
    update_post_meta($post_id, '_backorders', 'no');
    update_post_meta($post_id, '_stock', '');
    wp_reset_postdata();
}