jQuery(document).ready(function ($) {

    $('#team_booking_revoke_personal_token').click(function (e) {
        e.preventDefault();
        $('#tb-personal-token-revoke-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function () {
                    $.post(
                        TB_vars.post_url,
                        {
                            action                                    : 'option_submit',
                            _wpnonce                                  : TB_vars.wpNonce,
                            team_booking_revoke_personal_token_confirm: true
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            window.location.href = response;
                        }
                    );
                }
            })
            .uiModal('show')
        ;
    });
    $('.tbk-add-google-calendar').click(function (e) {
        e.preventDefault();
        $('#tbk-gcal-not-found').hide();
        $('#tb-personal-add-calendar-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    var calendar_id = $('#tb-personal-add-calendar-id').val();
                    if (!calendar_id) return false;
                    $clicked.addClass('loading');
                    $('#tbk-gcal-not-found').hide();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                          : 'option_submit',
                            _wpnonce                        : TB_vars.wpNonce,
                            team_booking_add_google_calendar: true,
                            calendar_id                     : calendar_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === '404') {
                                $('#tbk-gcal-not-found').show();
                                $clicked.removeClass('loading');
                            } else {
                                window.location.href = response;
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.tb-sync-all-calendars').click(function (e) {
        var $clicked = $(this);
        if ($clicked.hasClass('tbk-loading')) {
            return false;
        }
        e.preventDefault();
        $clicked.addClass('tbk-loading');
        var coworker = $clicked.data('coworker');
        var $progress = $('<progress>');
        var $cell = $clicked.closest('tr').find('.tbk-calendars-state').closest('td');
        $cell.find('.tbk-calendars-state').hide();
        $cell.append($progress);
        $.post(
            TB_vars.post_url,
            {
                action                                : 'option_submit',
                _wpnonce                              : TB_vars.wpNonce,
                team_booking_sync_all_google_calendars: true,
                coworker                              : coworker
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                if (response.slice(0, 4) == 'http') {
                    location.reload();
                } else {
                    $clicked.removeClass('tbk-loading');
                    $cell.find('.tbk-calendars-state').replaceWith(response);
                    $progress.remove();
                    console.log('full sync complete');
                }
            }
        );
    })
    $('.tb-sync-calendar-id').click(function (e) {
        var $clicked = $(this);
        if ($clicked.hasClass('tbk-loading')) {
            return false;
        }
        e.preventDefault();
        $clicked.addClass('tbk-loading');
        var calendar_id = $clicked.data('key');
        var $progress = $('<progress>');
        var $cell = $clicked.closest('tr').find('.tbk-calendar-state-sync, .tbk-calendar-state-not-sync').closest('td');
        $cell.find('.tbk-calendar-state-sync, .tbk-calendar-state-not-sync').hide();
        $cell.append($progress);
        $.post(
            TB_vars.post_url,
            {
                action                           : 'option_submit',
                _wpnonce                         : TB_vars.wpNonce,
                team_booking_sync_google_calendar: true,
                calendar_id                      : calendar_id
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                if (response.slice(0, 4) == 'http') {
                    location.reload();
                } else {
                    $cell.find('.tbk-calendar-state-sync').show();
                    $progress.remove();
                    $clicked.removeClass('tbk-loading');
                    console.log('full sync complete');
                }
            }
        );
    })
    $('.tbk-service-action-email, .tbk-service-action-calendar, .tbk-service-action-form, .tbk-service-action-settings').click(function (e) {
        $('.tbk-action-button').removeClass('tbk-loading');
        $(this).addClass('tbk-loading');
    })
    $('.tb-remove-calendar-id').click(function (e) {
        e.preventDefault();
        var calendar_id_key = $(this).data('key');
        $('#tb-personal-remove-calendar-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('tbk-loading') === false) {
                        $clicked.addClass('tbk-loading');
                        $.post(
                            TB_vars.post_url,
                            {
                                action                             : 'option_submit',
                                _wpnonce                           : TB_vars.wpNonce,
                                team_booking_remove_google_calendar: true,
                                calendar_id_key                    : calendar_id_key
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                    }
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.tb-clean-calendar-id').click(function (e) {
        e.preventDefault();
        var calendar_id_key = $(this).data('key');
        $('#tb-personal-clean-calendar-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('tbk-loading') === false) {
                        $clicked.addClass('tbk-loading');
                        $.post(
                            TB_vars.post_url,
                            {
                                action                            : 'option_submit',
                                _wpnonce                          : TB_vars.wpNonce,
                                team_booking_clean_google_calendar: true,
                                calendar_id_key                   : calendar_id_key
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                    }
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.tbk-revoke-coworker-token').click(function (e) {
        e.preventDefault();
        var coworker_id = $(this).data('coworker');
        var coworker_name = $(this).data('name');
        $('#tb-coworker-token-revoke-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onShow    : function () {
                    $('#revoke-coworker-name').html(coworker_name);
                },
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('tbk-loading') === false) {
                        $clicked.addClass('tbk-loading');
                        $.post(
                            TB_vars.post_url,
                            {
                                action                                    : 'option_submit',
                                _wpnonce                                  : TB_vars.wpNonce,
                                team_booking_revoke_coworker_token_confirm: true,
                                coworker_id                               : coworker_id
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                    }
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.tbk-coworkers-action-settings').on('click', function (e) {
        e.preventDefault();
        var coworker_id = $(this).data('coworker');
        var modal_id = '#tb-coworker-settings-modal-' + coworker_id;
        $(modal_id)
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('tbk-loading') === false) {
                        $clicked.addClass('tbk-loading');
                        var form_data = $('#team-booking-coworker-settings-form-' + coworker_id).serialize();
                        $.post(
                            TB_vars.post_url,
                            {
                                action                             : 'option_submit',
                                _wpnonce                           : TB_vars.wpNonce,
                                team_booking_save_coworker_settings: true,
                                coworker_id                        : coworker_id,
                                form_data                          : form_data
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                    }
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.tb-remove-residual-data').click(function () {
        var coworker_id = $(this).data('coworker');
        $.post(
            TB_vars.post_url,
            {
                action                               : 'option_submit',
                _wpnonce                             : TB_vars.wpNonce,
                team_booking_remove_coworker_residual: true,
                coworker_id                          : coworker_id,
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                window.location.href = response;
            }
        );
    });
    $('.tbk-show-pending-payments').on('click', function () {
        $(this).closest('.tbk-panel').find('table.widefat').addClass('tbk-loading');
    });
    $('.clean-error-logs').click(function (e) {
        e.preventDefault();
        $.post(
            TB_vars.post_url,
            {
                action                       : 'option_submit',
                _wpnonce                     : TB_vars.wpNonce,
                team_booking_clean_error_logs: true,
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                window.location.href = response;
            }
        );
    });
    $('[id^=tb-modal-]').on('click', '.header > .label', function () {
        var modal_id = '#tb-modal-' + $(this).closest('[id^=tb-modal-]').data('id');
        if ($(this).hasClass('tbk-edit-reservation-data')) {
            $(this).toggleClass('selected');
            $(modal_id + ' .tbk-edit-reservation-data-save').toggle();
            $(modal_id + ' .tb-customer-details input:not(.noedit)').each(function () {
                var ro = $(this).prop('readonly');
                $(this).prop('readonly', !ro);
            });
        } else if ($(this).hasClass('tbk-print-reservation-data')) {
            $(this).addClass('tbk-loading');
            var form = $('#tb-print-reservation-data-form');
            var reservation_id = $("<input>")
                .attr("type", "hidden")
                .attr("name", "reservation_id")
                .val($(this).data('id'));
            form.append($(reservation_id));
            form.submit();
        } else {
            $(modal_id + ' > .header > .label').removeClass('blue');
            $(this).addClass('blue');
            $(modal_id + ' .tb-data').hide();
            var to_show = jQuery(this).data('show');
            if (to_show !== 'tb-customer-details') {
                $(modal_id + ' .tbk-edit-reservation-data').hide();
                $(modal_id + ' .tbk-edit-reservation-data-save').hide();
            } else {
                $(modal_id + ' .tbk-edit-reservation-data').show();
                if ($(modal_id + ' .tbk-edit-reservation-data').hasClass('selected')) {
                    $(modal_id + ' .tbk-edit-reservation-data-save').show();
                }
            }
            $(modal_id + ' .' + to_show).show();
        }
    });
    $('.tbk-edit-reservation-data-save').click(function () {
        var button = $(this);
        button.toggleClass('loading');
        var reservation_id = $(this).data('id');
        var fields = {};
        button.closest(".ui.small.modal").find('.tb-customer-details input:not(.noedit)').each(function () {
            var key = $(this).data('key');
            fields[key] = $(this).val();
            $(this).prop('readonly', true);
        });
        $.post(
            TB_vars.post_url,
            {
                action                            : 'option_submit',
                _wpnonce                          : TB_vars.wpNonce,
                team_booking_edit_reservation_data: true,
                reservation_id                    : reservation_id,
                fields                            : JSON.stringify(fields)
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                console.log(response);
                button.toggleClass('loading');
                button.closest(".ui.small.modal").find('.tb-customer-details input:not(.noedit)').each(function () {
                    $(this).prop('readonly', false);
                });
            }
        );
    });

    flatpickr('.tb-flatpickr', {static: true});

    $('#add-new-promotion-coupon').click(function (e) {
        e.preventDefault();
        var $modal = $('#tb-new-promotion-modal-coupon');
        $modal
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $modal.find('p.error').hide();
                    // validation
                    $modal.find('input[required]').each(function () {
                        if (!$(this).val()) {
                            $(this).addClass('tbk-field-required');
                        } else {
                            $(this).removeClass('tbk-field-required');
                        }
                    });
                    if ($modal.find('input.tbk-field-required').length > 0) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    var coupon_name = $modal.find('input[name="promotion_name"]').val();
                    var coupon_discount = $modal.find('input[name="discount_value"]').val();
                    var coupon_discount_type = $modal.find('input[name="coupon-discount_type"]:checked').val();
                    var coupon_start = $modal.find('input[name="start_date"]').val();
                    var coupon_end = $modal.find('input[name="end_date"]').val();
                    var coupon_services = $modal.find('input[type="checkbox"]:checked').map(function () {
                        return this.value;
                    }).get();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                    : 'option_submit',
                            _wpnonce                  : TB_vars.wpNonce,
                            team_booking_insert_coupon: true,
                            coupon_name               : coupon_name,
                            coupon_discount           : coupon_discount,
                            coupon_discount_type      : coupon_discount_type,
                            coupon_start              : coupon_start,
                            coupon_end                : coupon_end,
                            coupon_services           : coupon_services
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'ok') {
                                location.reload();
                            } else {
                                console.log(response);
                                if (response.toLowerCase().indexOf("name_fail") >= 0) {
                                    $modal.find('p.error.name').show();
                                }
                                if (response.toLowerCase().indexOf("start_date_fail") >= 0) {
                                    $modal.find('p.error.start-date').show();
                                }
                                if (response.toLowerCase().indexOf("end_date_fail") >= 0) {
                                    $modal.find('p.error.end-date').show();
                                }
                                $clicked.removeClass('loading');
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
    });

    $('#add-new-promotion-campaign').click(function (e) {
        e.preventDefault();
        var $modal = $('#tb-new-promotion-modal-campaign');
        $modal
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $modal.find('p.error').hide();
                    // validation
                    $modal.find('input[required]').each(function () {
                        if (!$(this).val()) {
                            $(this).addClass('tbk-field-required');
                        } else {
                            $(this).removeClass('tbk-field-required');
                        }
                    });
                    if ($modal.find('input.tbk-field-required').length > 0) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    var campaign_name = $modal.find('input[name="promotion_name"]').val();
                    var campaign_discount = $modal.find('input[name="discount_value"]').val();
                    var campaign_discount_type = $modal.find('input[name="campaign-discount_type"]:checked').val();
                    var campaign_start = $modal.find('input[name="start_date"]').val();
                    var campaign_end = $modal.find('input[name="end_date"]').val();
                    var campaign_services = $modal.find('input[type="checkbox"]:checked').map(function () {
                        return this.value;
                    }).get();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                      : 'option_submit',
                            _wpnonce                    : TB_vars.wpNonce,
                            team_booking_insert_campaign: true,
                            campaign_name               : campaign_name,
                            campaign_discount           : campaign_discount,
                            campaign_discount_type      : campaign_discount_type,
                            campaign_start              : campaign_start,
                            campaign_end                : campaign_end,
                            campaign_services           : campaign_services
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'ok') {
                                location.reload();
                            } else {
                                console.log(response);
                                if (response.toLowerCase().indexOf("name_fail") >= 0) {
                                    $modal.find('p.error.name').show();
                                }
                                if (response.toLowerCase().indexOf("start_date_fail") >= 0) {
                                    $modal.find('p.error.start-date').show();
                                }
                                if (response.toLowerCase().indexOf("end_date_fail") >= 0) {
                                    $modal.find('p.error.end-date').show();
                                }
                                $clicked.removeClass('loading');
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
    });

    $('.tbk-promotion-action-edit').click(function (e) {
        e.preventDefault();
        var promotion_db_id = $(this).data('id');
        var promotion = $(this).data('promotion');
        var $modal = $('#' + promotion + '-edit-modal');
        $modal
            .find('span[id$="-discounted"]')
            .each(function () {
                $(this).autoNumeric('init');
                $(this).autoNumeric('update');
            });
        $modal
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $modal.find('p.error').hide();
                    // validation
                    $modal.find('input[required]').each(function () {
                        if (!$(this).val()) {
                            $(this).addClass('tbk-field-required');
                        } else {
                            $(this).removeClass('tbk-field-required');
                        }
                    });
                    if ($modal.find('input.tbk-field-required').length > 0) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    var promotion_name = $modal.find('input[name="promotion_name"]').val();
                    var promotion_discount = $modal.find('input[name="discount_value"]').val();
                    var promotion_discount_type = $modal.find('input[name="' + promotion_name + '-discount_type"]:checked').val();
                    var promotion_start = $modal.find('input[name="start_date"]').val();
                    var promotion_end = $modal.find('input[name="end_date"]').val();
                    var promotion_services = $modal.find('input[type="checkbox"]:checked').map(function () {
                        return this.value;
                    }).get()
                    $.post(
                        TB_vars.post_url,
                        {
                            action                   : 'option_submit',
                            _wpnonce                 : TB_vars.wpNonce,
                            team_booking_edit_pricing: true,
                            pricing_name             : promotion_name,
                            pricing_discount         : promotion_discount,
                            pricing_discount_type    : promotion_discount_type,
                            pricing_start            : promotion_start,
                            pricing_end              : promotion_end,
                            pricing_services         : promotion_services,
                            pricing_db_id            : promotion_db_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'ok') {
                                location.reload();
                            } else {
                                console.log(response);
                                if (response.toLowerCase().indexOf("name_fail") >= 0) {
                                    $modal.find('p.error.name').show();
                                }
                                if (response.toLowerCase().indexOf("start_date_fail") >= 0) {
                                    $modal.find('p.error.start-date').show();
                                }
                                if (response.toLowerCase().indexOf("end_date_fail") >= 0) {
                                    $modal.find('p.error.end-date').show();
                                }
                                $clicked.removeClass('loading');
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
    })
    $('.tbk-promotion-action-pause, .tbk-promotion-action-run').click(function (e) {
        e.preventDefault();
        var $clicked = $(this);
        if ($clicked.hasClass('tbk-loading')) return false;
        $clicked.addClass('tbk-loading');
        var promotion_id = $(this).data('id');
        var status = 'run';
        if ($(this).hasClass('tbk-promotion-action-pause')) {
            status = 'pause';
        }
        $.post(
            TB_vars.post_url,
            {
                action                            : 'option_submit',
                _wpnonce                          : TB_vars.wpNonce,
                team_booking_pricing_status_change: true,
                status                            : status,
                pricing_id                        : promotion_id
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                if (response === 'ok') {
                    location.reload();
                } else {
                    console.log(response);
                    $clicked.addClass('tbk-loading');
                }
            }
        );
    })
    $('.tbk-promotion-action-delete').click(function (e) {
        e.preventDefault();
        var promotion_id = $(this).data('id');
        var promotion_name = $(this).data('name');
        $('#tbk-promotion-delete-modal').find('.promotion-name').html(promotion_name);
        $('#tbk-promotion-delete-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    $.post(
                        TB_vars.post_url,
                        {
                            action                     : 'option_submit',
                            _wpnonce                   : TB_vars.wpNonce,
                            team_booking_delete_pricing: true,
                            pricing_id                 : promotion_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'ok') {
                                location.reload();
                            } else {
                                console.log(response)
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
    });

    $('.team-booking-new-service').click(function (e) {
        e.preventDefault();
        $('#tb-booking-new-service-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $('#tbk-new-id-already-existant').hide();
                    $('#tbk-new-name-already-existant').hide();
                    $clicked.addClass('loading');
                    var new_service_id = $('#tb-booking-new-service-id').val();
                    var new_service_name = $('#tb-booking-new-service-name').val();
                    var new_service_class = $('input[name=class]:checked', '#tb-booking-new-service-modal').val();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                          : 'option_submit',
                            _wpnonce                        : TB_vars.wpNonce,
                            team_booking_insert_booking_type: true,
                            id                              : new_service_id,
                            name                            : new_service_name,
                            class                           : new_service_class
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'ok') {
                                location.reload();
                            } else {
                                if (response === 'id_fail') {
                                    $('#tbk-new-id-already-existant').show();
                                }
                                if (response === 'name_fail') {
                                    $('#tbk-new-name-already-existant').show();
                                }
                                if (response === 'id_fail name_fail') {
                                    $('#tbk-new-id-already-existant').show();
                                    $('#tbk-new-name-already-existant').show();
                                }
                                $clicked.removeClass('loading');
                            }

                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.team-booking-clone-service').click(function (e) {
        e.preventDefault();
        var service_id = $(this).data('serviceid');
        $('#tb-booking-clone-service-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onShow    : function () {
                    $('#tbk-clone-id-already-existant').hide();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                               : 'option_submit',
                            _wpnonce                             : TB_vars.wpNonce,
                            team_booking_clone_service_suggestion: true,
                            service_id                           : service_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            $('#tb-booking-clone-service-new-id').val(response);
                        }
                    );
                },
                onApprove : function ($clicked) {
                    $('#tbk-clone-id-already-existant').hide();
                    $clicked.addClass('loading');
                    var new_service_id = $('#tb-booking-clone-service-new-id').val();
                    $.post(
                        TB_vars.post_url,
                        {
                            action                    : 'option_submit',
                            _wpnonce                  : TB_vars.wpNonce,
                            team_booking_clone_service: true,
                            service_id                : service_id,
                            new_service_id            : new_service_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response === 'id already used') {
                                $('#tbk-clone-id-already-existant').show();
                                $clicked.removeClass('loading');
                            } else {
                                location.reload();
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.team-booking-delete-service').click(function (e) {
        e.preventDefault();
        var service = $(this).data('servicename');
        var service_id = $(this).data('serviceid');
        $('#tb-booking-delete-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onShow    : function () {
                    $(this).find('.service-name').text(service)
                },
                onApprove : function () {
                    $.post(
                        TB_vars.post_url,
                        {
                            action                             : 'option_submit',
                            _wpnonce                           : TB_vars.wpNonce,
                            team_booking_delete_booking_confirm: true,
                            booking_id                         : service_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            window.location.href = response;
                        }
                    );
                }
            })
            .uiModal('show')
        ;
    });
    $('.team-booking-approve-reservation').click(function (e) {
        e.preventDefault();
        var reservation_id = $(this).data('reservationid');
        var modal_id = '#tb-reservation-approve-modal-' + reservation_id;
        $(modal_id + ' p.error').hide();
        $(modal_id)
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    $clicked.addClass('loading');
                    $.post(
                        TB_vars.post_url,
                        {
                            action                                  : 'option_submit',
                            _wpnonce                                : TB_vars.wpNonce,
                            team_booking_approve_reservation_confirm: true,
                            reservation_id                          : reservation_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response.substr(0, 5) === 'ERROR') {
                                $clicked.removeClass('loading');
                                $(modal_id + ' p.error').show();
                                $(modal_id + ' p.error > span').html(response);
                            } else {
                                window.location.href = response;
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.team-booking-confirm-pending-reservation').click(function (e) {
        e.preventDefault();
        var reservation_id = $(this).data('reservationid');
        var modal_id = '#tb-reservation-confirm-pending-modal-' + reservation_id;
        $(modal_id + ' p.error').hide();
        $(modal_id)
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    $clicked.addClass('loading');
                    $.post(
                        TB_vars.post_url,
                        {
                            action                                          : 'option_submit',
                            _wpnonce                                        : TB_vars.wpNonce,
                            team_booking_confirm_pending_reservation_confirm: true,
                            set_as_paid                                     : $clicked.hasClass('tbk-secondary'),
                            reservation_id                                  : reservation_id
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response.substr(0, 5) === 'ERROR') {
                                $clicked.removeClass('loading');
                                $(modal_id + ' p.error').show();
                                $(modal_id + ' p.error > span').html(response);
                            } else {
                                window.location.href = response;
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });
    $('.team-booking-delete-reservation, .team-booking-cancel-reservation').click(function (e) {
        e.preventDefault();
        var reservation_id = $(this).data('reservationid');
        var is_pending = $(this).data('pending');
        var is_previously_confirmed = $(this).data('previouslyconfirmed');
        var reason;
        var operation;
        if ($(this).hasClass('team-booking-delete-reservation')) {
            $('#tb-reservation-delete-modal #multiple-delete').hide();
            $('#tb-reservation-delete-modal #single-delete').show();
            $('#tb-reservation-delete-modal')
                .uiModal({
                    blurring  : true,
                    transition: 'fade up',
                    onApprove : function ($clicked) {
                        $clicked.addClass('tbk-loading');
                        operation = 'delete';
                        $.post(
                            TB_vars.post_url,
                            {
                                action                                 : 'option_submit',
                                _wpnonce                               : TB_vars.wpNonce,
                                team_booking_delete_reservation_confirm: true,
                                operation                              : operation,
                                reason                                 : reason,
                                is_pending                             : is_pending,
                                reservation_id                         : reservation_id
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                        return false;
                    }
                })
                .uiModal('show')
            ;
        } else {
            $('#tb-reservation-cancel-modal .previously-confirmed').show();
            if (is_previously_confirmed === 'no') {
                $('#tb-reservation-cancel-modal .previously-confirmed').hide();
            }
            $('#tb-reservation-cancel-modal')
                .uiModal({
                    blurring  : true,
                    transition: 'fade up',
                    onApprove : function ($clicked) {
                        operation = 'cancel';
                        reason = $(this).find('textarea#reason').val();
                        $clicked.addClass('loading');
                        $.post(
                            TB_vars.post_url,
                            {
                                action                                 : 'option_submit',
                                _wpnonce                               : TB_vars.wpNonce,
                                team_booking_delete_reservation_confirm: true,
                                operation                              : operation,
                                reason                                 : reason,
                                reservation_id                         : reservation_id
                            },
                            function (response) {
                                response = tbUnwrapAjaxResponse(response);
                                window.location.href = response;
                            }
                        );
                        return false;
                    }
                })
                .uiModal('show')
            ;
        }
    });
    $('#tb-delete-all-reservations-modal')
        .uiModal({
            blurring  : true,
            transition: 'fade up',
            onApprove : function () {
                if ($('.delete_all_tb_reservations').hasClass('pending')) {
                    var is_pending = 1;
                } else {
                    var is_pending = 0;
                }
                $.post(
                    TB_vars.post_url,
                    {
                        action                                      : 'option_submit',
                        _wpnonce                                    : TB_vars.wpNonce,
                        is_pending                                  : is_pending,
                        team_booking_delete_all_reservations_confirm: true
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        window.location.href = response;
                    }
                );
            }
        })
        .uiModal('attach events', '.delete_all_tb_reservations', 'show')
    ;
    // Get the CSV log file
    $('.tb-get-csv').click(function (e) {
        e.preventDefault();
        $('#tb-get-csv-form').submit();
    });
    // Get the CSV customers file
    $('.tb-get-customers-csv').click(function (e) {
        e.preventDefault();
        $('#tb-get-customers-csv-form').submit();
    });
    // Get the XLSX log file
    $('.tb-get-xlsx').click(function (e) {
        e.preventDefault();
        $('#tb-get-xlsx-form').submit();
    });
    // Get the XLSX customers file
    $('.tb-get-customers-xlsx').click(function (e) {
        e.preventDefault();
        $('#tb-get-customers-xlsx-form').submit();
    });
    // Add a custom field
    $('.tb-add-custom-field').click(function (e) {
        e.preventDefault();
        var field = $(this).data('field');
        var serviceid = $(this).data('serviceid');
        var $field_area = $(this).closest('.tbk-panel').find('.tb-custom-fields-list');
        $field_area.addClass('tbk-loading');
        $.post(
            TB_vars.post_url,
            {
                action                       : 'option_submit',
                _wpnonce                     : TB_vars.wpNonce,
                team_booking_add_custom_field: true,
                field                        : field,
                service_id                   : serviceid
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                if ($('.tb-no-custom-fields').length) {
                    $('.tb-no-custom-fields').remove();
                }
                $('.tb-custom-fields-list').append(response);
                $('body, html').animate({scrollTop: $(".tb-custom-fields-list li:last").offset().top}, 1000);
                $field_area.removeClass('tbk-loading');
            }
        );
    });
    // Remove a custom field
    $('.tb-custom-fields-list').on("click", ".tb-remove-custom-field", function (e) {
        e.preventDefault();
        var hook = $(this).data('hook');
        var serviceid = $(this).data('serviceid');
        var $clicked = $(this).closest('.tb-custom-field-draggable');
        $clicked.addClass('tbk-loading');
        $(this).parents().eq(5).addClass('toberemoved');
        $.post(
            TB_vars.post_url,
            {
                action                          : 'option_submit',
                _wpnonce                        : TB_vars.wpNonce,
                team_booking_remove_custom_field: true,
                hook                            : hook,
                service_id                      : serviceid
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                $('.toberemoved').next('br').remove();
                $('.toberemoved').remove();
                $clicked.removeClass('tbk-loading');
            }
        );
    });
    // Save a custom field
    $('.tb-custom-fields-list').on("click", ".tb-save-custom-field", function (e) {
        e.preventDefault();
        if ($(this).hasClass('tobesaved')) {
            return;
        }
        var hook = $(this).data('hook');
        var serviceid = $(this).data('serviceid');
        var custom_field = $(this).parents().eq(5);
        var inputs = custom_field.find('input, select').serialize();
        var $clicked = $(this).closest('.tb-custom-field-draggable');
        $clicked.addClass('tbk-loading');
        $(this).addClass('tobesaved').attr("disabled", true);
        $.post(
            TB_vars.post_url,
            {
                action                        : 'option_submit',
                _wpnonce                      : TB_vars.wpNonce,
                team_booking_save_custom_field: true,
                hook                          : hook,
                service_id                    : serviceid,
                inputs                        : inputs
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
                if (response === 'duplicate_hook') {
                    $(".tobesaved").attr("disabled", false);
                    alert('Hook already existant! Please choose another one.'); //TODO: better handling
                } else {
                    if (response !== 'ok') {
                        console.log(response);
                    }
                    $(".tobesaved").attr("disabled", false).removeClass('tobesaved');
                }
                $clicked.removeClass('tbk-loading');
            }
        );
    });
    // Expand custom field
    $('.tb-custom-fields-list').on("click", ".tb-expand-handle", function (e) {
        $(this).closest('li').find('.tb-custom-field-draggable').addClass('expanded');
        $(this).closest('li').find('.tb-hide').show();
        $(this).closest('li').find('.tb-collapse-handle').show();
        $(this).hide();
    });
    // Collapse custom field
    $('.tb-custom-fields-list').on("click", ".tb-collapse-handle", function (e) {
        $(this).closest('li').find('.tb-custom-field-draggable').removeClass('expanded');
        $(this).closest('li').find('.tb-hide').hide();
        $(this).closest('li').find('.tb-expand-handle').show();
        $(this).hide();
    });
    // Add custom field option
    $('.tb-custom-fields-list').on("click", ".tb-add-option-handle", function (e) {
        var $sibling = $(this).closest('tr').prev('tr');
        var trs = $(this).closest('table').find('tr')[0];
        var tds = $(trs).find('td');
        $(tds[0]).attr('rowspan', parseInt($(tds[0]).attr('rowspan')) + 1);
        $(tds[1]).attr('rowspan', parseInt($(tds[1]).attr('rowspan')) + 1);
        if ($sibling.find('input.single-option').length === 1) {
            var $cloned = $sibling.clone();
            var $inputs = $cloned.find('input');
            $inputs.each(function () {
                var nth = 0;
                var name = $(this).attr('name');
                $(this).attr('name', name.replace(/\[.+?\]/g, function (match, pos, original) {
                    nth++;
                    return (nth == 4) ? '[' + $sibling.closest('table').find('.single-option').length + ']' : match;
                }));
                if ($(this).hasClass('all-options')) {
                    $(this).attr('value', '');
                } else {
                    $(this).attr('value', '0.00');
                }
            });
            $sibling.after($cloned);
        } else {
            var $cloned = $sibling.clone();
            $cloned.find('td').prepend('<span class="dashicons dashicons-dismiss tb-delete-option-handle"></span>');
            var nth = 0;
            var name_label = $cloned.find('input.all-options').attr('name').slice(0, -15) + 'options][0][label]';
            var name_price_increment = $cloned.find('input.all-options').attr('name').slice(0, -15) + 'options][0][price_increment]';
            $cloned.find('input.all-options').attr('name', name_label).attr('value', '').addClass('single-option');
            $cloned.find('input[type=hidden]').attr('name', name_price_increment).attr('value', '0.00');
            $sibling.after($cloned);
        }
    });
    // Remove custom field option
    $('.tb-custom-fields-list').on("click", ".tb-delete-option-handle", function (e) {
        var trs = $(this).closest('table').find('tr')[0];
        var tds = $(trs).find('td');
        $(tds[0]).attr('rowspan', parseInt($(tds[0]).attr('rowspan')) - 1);
        $(tds[1]).attr('rowspan', parseInt($(tds[1]).attr('rowspan')) - 1);
        $(this).closest('tr').remove();
        var counter = 0;
        $(trs).closest('table').find('.single-option').each(function () {
            var nth = 0;
            var name = $(this).attr('name');
            $(this)
                .attr('name', name.replace(/\[.+?\]/g, function (match, pos, original) {
                    nth++;
                    return (nth == 4) ? '[' + counter + ']' : match;
                }))
            ;
            var nth = 0;
            var name = $(this).next('input').attr('name');
            $(this).next('input')
                .attr('name', name.replace(/\[.+?\]/g, function (match, pos, original) {
                    nth++;
                    return (nth == 4) ? '[' + counter + ']' : match;
                }))
            ;
            counter++;
        });
    });
    // Open custom field advanced option settings
    $('.tb-custom-fields-list').on("click", ".tb-advanced-option-handle", function (e) {
        var $handle = $(this);
        var $modal = $('#' + $(this).data('modal'));
        var $option = $(this).closest('td').find('input.all-options');
        $modal
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onShow    : function () {
                    $modal.find('input[name="price_increment"]').attr('value', $option.next('input').val());
                },
                onApprove : function () {
                    var price_increment = parseFloat($modal.find('input[name="price_increment"]').val()).toFixed(2);
                    if (isNaN(price_increment)) {
                        price_increment = '0.00';
                    }
                    if (price_increment > 0) {
                        $handle.addClass('active');
                    } else {
                        $handle.removeClass('active');
                    }
                    $option.next('input').attr('value', price_increment);
                }
            })
            .uiModal('show')
        ;
    });
    // Draggable custom fields
    $(".sortable").sortable({
        axis           : "y",
        handle         : ".tb-drag-handle",
        placeholder    : "tb-placeholder",
        opacity        : 0.5,
        scroll         : false,
        forceHelperSize: true,
        update         : function (event, ui) {
            var hook = ui.item.find('.tb-save-custom-field').data('hook');
            var serviceid = ui.item.find('.tb-save-custom-field').data('serviceid');
            var where = ui.item.index();
            var $moved = ui.item.find('.tb-custom-field-draggable');
            $moved.addClass('tbk-loading');
            $.post(
                TB_vars.post_url,
                {
                    action                        : 'option_submit',
                    _wpnonce                      : TB_vars.wpNonce,
                    team_booking_move_custom_field: true,
                    hook                          : hook,
                    service_id                    : serviceid,
                    where                         : where
                },
                function (response) {
                    response = tbUnwrapAjaxResponse(response);
                    $moved.removeClass('tbk-loading');
                }
            );
        }
    });

    $('#remove-selected-reservations').on('click', function (e) {
        // preventing default anchor action
        e.preventDefault();
        // see if reservations are pending
        var is_pending = $(this).data('pending');
        // collecting reservation ids
        var reservations = [];
        $('#tbk-reservations-overview .tb-table-select-row:checked').each(function () {
            reservations.push($(this).data('row'));
        });
        // configuring and calling the confirmation modal
        $('#tb-reservation-delete-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    $.post(
                        TB_vars.post_url,
                        {
                            action                                   : 'option_submit',
                            _wpnonce                                 : TB_vars.wpNonce,
                            team_booking_remove_selected_reservations: true,
                            is_pending                               : is_pending,
                            reservations                             : JSON.stringify(reservations),
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response.slice(0, 4) == 'http') {
                                location.reload();
                            } else {
                                $clicked.removeClass('loading');
                                console.log(response);
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });

    $('#remove-selected-services').on('click', function (e) {
        // preventing default anchor action
        e.preventDefault();
        // collecting services ids
        var services = [];
        $('#tbk-services-list .tb-table-select-row:checked').each(function () {
            services.push($(this).data('row'));
        });
        // configuring and calling the confirmation modal
        $('#tb-service-delete-selected-modal')
            .uiModal({
                blurring  : true,
                transition: 'fade up',
                onApprove : function ($clicked) {
                    if ($clicked.hasClass('loading')) {
                        return false;
                    }
                    $clicked.addClass('loading');
                    $.post(
                        TB_vars.post_url,
                        {
                            action                               : 'option_submit',
                            _wpnonce                             : TB_vars.wpNonce,
                            team_booking_remove_selected_services: true,
                            services                             : JSON.stringify(services),
                        },
                        function (response) {
                            response = tbUnwrapAjaxResponse(response);
                            if (response.slice(0, 4) == 'http') {
                                location.reload();
                            } else {
                                $clicked.removeClass('loading');
                                console.log(response);
                            }
                        }
                    );
                    return false;
                }
            })
            .uiModal('show')
        ;
    });

    tbToggleService = function (activate, service_id, personal) {
        $.post(
            TB_vars.post_url,
            {
                action                     : 'option_submit',
                _wpnonce                   : TB_vars.wpNonce,
                service_action             : activate,
                team_booking_toggle_service: true,
                service_id                 : service_id,
                personal                   : personal
            },
            function (response) {
                response = tbUnwrapAjaxResponse(response);
            }
        );
    };

    tbToggleCalendarIndependency = function (indep, calendar_id) {
        $.post(
            TB_vars.post_url,
            {
                action                                   : 'option_submit',
                _wpnonce                                 : TB_vars.wpNonce,
                independent                              : indep,
                team_booking_toggle_calendar_independency: true,
                calendar_id                              : calendar_id
            },
            function (response) {
                console.log(tbUnwrapAjaxResponse(response));
            }
        );
    };

    tbInsertAtCaret = function (areaId, text) {
        var txtarea = document.getElementById(areaId);
        var scrollPos = txtarea.scrollTop;
        var strPos = 0;
        var br = ((txtarea.selectionStart || txtarea.selectionStart === '0') ?
            "ff" : (document.selection ? "ie" : false));
        if (br === "ie") {
            txtarea.focus();
            var range = document.selection.createRange();
            range.moveStart('character', -txtarea.value.length);
            strPos = range.text.length;
        }
        else if (br === "ff")
            strPos = txtarea.selectionStart;
        var front = (txtarea.value).substring(0, strPos);
        var back = (txtarea.value).substring(strPos, txtarea.value.length);
        txtarea.value = front + text + back;
        strPos = strPos + text.length;
        if (br === "ie") {
            txtarea.focus();
            var range = document.selection.createRange();
            range.moveStart('character', -txtarea.value.length);
            range.moveStart('character', strPos);
            range.moveEnd('character', 0);
            range.select();
        }
        else if (br === "ff") {
            txtarea.selectionStart = strPos;
            txtarea.selectionEnd = strPos;
            txtarea.focus();
        }
        txtarea.scrollTop = scrollPos;
    };

    $('#team-booking-export-settings').click(function (e) {
        e.preventDefault();
        $('#team-booking-export-settings_form').submit();
    });

    $('#team-booking-import-settings_modal')
        .uiModal({
            blurring  : true,
            transition: 'fade up',
        })
        .uiModal('attach events', '#team-booking-import-settings', 'show')
        .find('.positive.button')
        .click(function (e) {
            e.preventDefault();
            $('#team-booking-import-settings_form').submit();
        })
    ;

    $('#team-booking-repair-database_modal')
        .uiModal({
            blurring  : true,
            transition: 'fade up',
            onApprove : function ($clicked) {
                $clicked.addClass('tbk-loading');
                $.post(
                    TB_vars.post_url,
                    {
                        action                      : 'option_submit',
                        _wpnonce                    : TB_vars.wpNonce,
                        team_booking_repair_database: true
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response.slice(0, 4) == 'http') {
                            window.location.replace(response);
                        } else {
                            $clicked.removeClass('tbk-loading');
                        }
                    }
                );
                return false;
            }
        })
        .uiModal('attach events', '#team-booking-repair-database', 'show')
    ;

    $('#team-booking-import-core-json_modal')
        .uiModal({
            blurring  : true,
            transition: 'fade up',
            onApprove : function ($clicked) {
                $clicked.addClass('loading');
                var form = $('#team-booking-import-core-json_form');
                form.find('.json-errors').hide();
                // File handling is done with FormData objects
                // It requires the jQuery.ajax method
                var data = new FormData();
                data.append('_wpnonce', TB_vars.wpNonce);
                data.append('action', 'option_submit');
                data.append('set_google_core_from_json', '1');
                form.find('input[type="file"]').each(function () {
                    var fileInputName = $(this).attr('name'); //settings_json_file
                    data.append(fileInputName, this.files[0]);
                });
                $.ajax({
                    url        : TB_vars.post_url,
                    type       : 'POST',
                    // Collect form data
                    data       : data,
                    processData: false,
                    contentType: false,
                    success    : function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response === 'no file') {
                            form.find('.no_file').show();
                        } else if (response === 'uri mismatch') {
                            form.find('.uri_mismatch').show();
                        } else if (response === 'invalid file') {
                            form.find('.invalid_file').show();
                        } else {
                            window.location.href = response;
                        }
                        $clicked.removeClass('loading');
                    }
                });
                return false;
            }
        })
        .uiModal('attach events', '#team-booking-import-core-json', 'show')
    ;

    $('.tbk-reset-customer-reservation-limit')
        .on('click keypress', function (e) {
            e.preventDefault();
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                var $clicked = $(this);
                var $table = $clicked.closest('table.widefat');
                $table.addClass('tbk-loading');
                $.post(
                    TB_vars.post_url,
                    {
                        action                                    : 'option_submit',
                        _wpnonce                                  : TB_vars.wpNonce,
                        team_booking_reset_enumerable_reservations: true,
                        service_id                                : $clicked.data('service'),
                        customer_id                               : $clicked.data('customer')
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response.slice(0, 4) == 'http') {
                            location.reload();
                        } else {
                            $clicked.closest('td').find('.tbk-customer-reservation-limit').removeClass('orange').addClass('green').html($clicked.data('text'));
                            $table.removeClass('tbk-loading');
                        }
                    }
                );
            }
        })

    $('.tbk-wrapper')
        .on('click keypress', '.tb-toggle-email-editor', function (e) {
            e.preventDefault();
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                $(this).toggleClass('orange');
                $(this).siblings('.tb-email-editor').slideToggle('fast');
            }
        })
        .on('click keypress', '.tb-hook-placeholder', function (e) {
            e.preventDefault();
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                var text = $(this).data('value');
                if (typeof $(this).data('open') !== "undefined") {
                    var open = $(this).data('open');
                    var close = $(this).data('close');
                    text = $.trim(prompt(text, text));
                    if (!text) {
                        text = $(this).data('value')
                    }
                    text = open + text + close;
                }
                var textarea_id = $(this).closest('li').find('textarea').attr("id");
                tbInsertAtCaret(textarea_id, text);
                $(this).closest('form').trigger('rescan.areYouSure');
            }
        })
        .on('click keypress', '#team-booking-new-token', function (e) {
            e.preventDefault();
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                var $table = $(this).closest('.tbk-panel').find('table.widefat');
                $table.addClass('tbk-loading');
                $.post(
                    TB_vars.post_url,
                    {
                        action                       : 'option_submit',
                        _wpnonce                     : TB_vars.wpNonce,
                        team_booking_create_api_token: true
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response.slice(0, 4) == 'http') {
                            location.reload();
                        } else {
                            $table.removeClass('tbk-loading');
                            console.log(response);
                        }
                    }
                );
            }
        })
        .on('click keypress', '#team-booking-new-token-write', function (e) {
            e.preventDefault();
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                var $table = $(this).closest('.tbk-panel').find('table.widefat');
                $table.addClass('tbk-loading');
                $.post(
                    TB_vars.post_url,
                    {
                        action                       : 'option_submit',
                        _wpnonce                     : TB_vars.wpNonce,
                        team_booking_create_api_token: true,
                        write                        : true
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response.slice(0, 4) == 'http') {
                            location.reload();
                        } else {
                            $table.removeClass('tbk-loading');
                            console.log(response);
                        }
                    }
                );
            }
        })
        .on('click keypress', '.tbk-token-action-delete', function (e) {
            e.preventDefault();
            var $clicked = $(this);
            if (e.which == 13 || e.which == 32 || e.which == 1) {
                $clicked.addClass('tbk-loading');
                var token = $(this).data('token');
                $.post(
                    TB_vars.post_url,
                    {
                        action                       : 'option_submit',
                        _wpnonce                     : TB_vars.wpNonce,
                        team_booking_revoke_api_token: true,
                        token                        : token
                    },
                    function (response) {
                        response = tbUnwrapAjaxResponse(response);
                        if (response.slice(0, 4) == 'http') {
                            location.reload();
                        } else {
                            $clicked.removeClass('tbk-loading');
                            console.log(response);
                        }
                    }
                );
            }
        })
        // Prevent some defaults
        .on('click keydown', '.tablenav-pages a', function (e) {
            e.preventDefault();
            $(this).blur();
        })
    ;

    $('.tbk-email-reminder-send-manually').on('click', function (e) {
        e.preventDefault();
        if (e.which == 13 || e.which == 32 || e.which == 1) {
            var $clicked = $(this);
            $clicked.closest('.tb-data').addClass('tbk-loading');
            var id = $(this).attr('data-id');
            $.post(
                TB_vars.post_url,
                {
                    action                                   : 'option_submit',
                    _wpnonce                                 : TB_vars.wpNonce,
                    team_booking_send_email_reminder_manually: true,
                    reservation_id                           : id
                },
                function (response) {
                    response = tbUnwrapAjaxResponse(response);
                    $clicked.closest('.tb-data').removeClass('tbk-loading');
                    if (response === 'ok') {
                        $clicked.parent().find('.tbk-email-reminder-sent').show();
                        $clicked.parent().find('.tbk-email-reminder-notsent').hide();
                        $clicked.remove();
                    } else {
                        alert('NOTICE: e-mail cannot be sent, the event is expired');
                    }
                }
            );
        }
    });

    $('.tbk-reservations-action-details').click(function (e) {
        e.preventDefault();
        var modal = $(this).data('modal');
        jQuery('#tb-modal-' + modal)
            .uiModal({
                blurring  : true,
                transition: 'fade up'
            })
            .uiModal('show');
    });

    $('.tb-show-customer-reservations').click(function (e) {
        e.preventDefault();
        var modal_id = $(this).data('modal');
        $('#' + modal_id)
            .uiModal({
                blurring  : true,
                transition: 'fade up',
            })
            .uiModal('show')
        ;
    });

    // AreYouSUre?
    $('form').areYouSure({'message': 'The changes you made will be lost if you navigate away from this page.'});

})
; // <-- end of document.ready

function tbUnwrapAjaxResponse(response) {
    var $return = response.replace(/^\s*[\r\n]/gm, "").match(/!!TBK-START!!(.*[\s\S]*)!!TBK-END!!/);
    if ($return === null) {
        console.log(response);
        return response;
    } else {
        return jQuery.trim($return[1]);
    }
}

(function ($) {
    // Add Color Picker to all inputs that have 'tb-color-field' class
    $(function () {
        $('.tb-color-field').wpColorPicker({
            change: function (event, ui) {
                var name = $(this).attr('name');
                // event = standard jQuery event, produced by whichever control was changed.
                // ui = standard jQuery UI object, with a color member containing a Color.js object
                var c = ui.color.toString().substring(1);      // strip #
                var rgb = parseInt(c, 16);   // convert rrggbb to decimal
                var r = (rgb >> 16) & 0xff;  // extract red
                var g = (rgb >> 8) & 0xff;  // extract green
                var b = (rgb >> 0) & 0xff;  // extract blue
                var luma = 0.2126 * r + 0.7152 * g + 0.0722 * b; // per ITU-R BT.709
                if (name === 'tb-background-color') {
                    $(".tb-frontend-calendar").css('background', ui.color.toString());
                    if (luma > 145) {
                        $(".tb-day:not(#free-slot, #soldout-slot), .tbk-row-preview").css('color', '#414141');
                    } else {
                        $(".tb-day:not(#free-slot, #soldout-slot), .tbk-row-preview").css('color', '#FFFFFF');
                    }
                } else if (name === 'tb-weekline-color') {
                    $("#week-line").css('background-color', ui.color.toString());
                    if (luma > 145) {
                        $("#week-line").css('color', '#414141');
                    } else {
                        $("#week-line").css('color', '#FFFFFF');
                    }
                }
                else if (name === 'tb-freeslot-color') {
                    $("#free-slot").css('background', ui.color.toString());
                    if (luma > 145) {
                        $("#free-slot").css('color', '#414141');
                    } else {
                        $("#free-slot").css('color', '#FFFFFF');
                    }
                }
                else if (name === 'tb-soldoutslot-color') {
                    $("#soldout-slot").css('background', ui.color.toString());
                    if (luma > 145) {
                        $("#soldout-slot").css('color', '#414141');
                    } else {
                        $("#soldout-slot").css('color', '#FFFFFF');
                    }
                }
            }
        });
    });
})(jQuery);