<?php

// Blocks direct access to this file
defined('ABSPATH') or die("No script kiddies please!");

/**
 * This class defines an error object used to return errors
 * to customer/frontend when a reservation fails.
 *
 * TODO: join TeamBooking_Error with TeamBooking_ErrorLog
 */
class TeamBooking_Error
{

    //------------------------------------------------------------

    private $code;
    private $message;

    public function __construct($code)
    {
        $this->code = $code;
        switch ($code) {
            case 1:
                $this->message = "The Coworker auth token is not present anymore";
                break;
            case 2:
                $this->message = "Slot not available anymore or cancelled";
                break;
            case 3:
                $this->message = "The customer has already booked the slot";
                break;
            case 4:
                $this->message = "The customer has entered an invalid email address";
                break;
            case 5:
                $this->message = "Generic Google API error"; // More specific with error message returned by Google
                break;
            case 6:
                $this->message = "The event is full";
                break;
            case 7:
                $this->message = "The event is already cancelled or not marked as booked anymore";
                break;
            case 8:
                $this->message = "The customer is trying to book a number of tickets that, together with his previous tickets, overcomes the maximum allowed";
                break;
            case 9:
                $this->message = "Can't decode the rendering parameters object";
                break;
            case 10:
                $this->message = "Operation not allowed for this service class";
                break;
        }
    }

    //------------------------------------------------------------

    public function getCode()
    {
        return $this->code;
    }

    public function getMessage()
    {
        return $this->message;
    }

    public function setMessage($message)
    {
        $this->message = $message;
    }

}
