<?php
// Blocks direct access to this file
defined('ABSPATH') or die("No script kiddies please!");

class TeamBooking_Promotions_Coupon implements \TeamBooking\Promotions\Promotion
{
    private $name;
    private $services;
    private $discount;
    private $discount_type;
    private $start_time;
    private $end_time;
    private $status;

    public function __construct()
    {
        $this->services = array();
    }

    //------------------------------------------------------------

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setStatus($boolean)
    {
        if ($boolean) {
            $this->status = TRUE;
        } else {
            $this->status = FALSE;
        }
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function addServices(array $services)
    {
        $this->services = $services;
    }

    public function addService($service_id)
    {
        $this->services[] = $service_id;
    }

    public function removeService($service_id)
    {
        foreach ($this->services as $id => $service) {
            if ($service_id == $service) {
                unset($this->services[$id]);
                break;
            }
        }

    }

    public function checkService($service_id)
    {
        if (in_array($service_id, $this->services)) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    public function deleteServices()
    {
        $this->services = array();
    }

    public function setDiscount($int)
    {
        $this->discount = (int)$int;
    }

    public function getDiscount()
    {
        return $this->discount;
    }

    public function setDiscountType($type)
    {
        switch ($type) {
            case 'percentage':
                $this->discount_type = 'percentage';
                break;
            default:
                $this->discount_type = 'direct';
        }
    }

    public function getDiscountType()
    {
        return $this->discount_type;
    }

    public function setStartTime($timestamp)
    {
        $this->start_time = $timestamp;
    }

    public function getStartTime()
    {
        return $this->start_time;
    }

    public function setEndTime($timestamp)
    {
        $this->end_time = $timestamp;
    }

    public function getEndTime()
    {
        return $this->end_time;
    }

    public function checkClass($class_name)
    {
        if ($class_name == 'coupon') {
            return TRUE;
        } else {
            return FALSE;
        }
    }
}