<?php

namespace TeamBooking;

// Blocks direct access to this file
defined('ABSPATH') or die("No script kiddies please!");

class RenderParameters
{
    private $month;
    private $year;
    private $day;
    private $service_ids;
    private $requested_service_ids;
    private $coworker_ids;
    private $requested_coworker_ids;
    private $is_widget;
    private $is_ajax_call;
    private $no_filter;
    private $no_timezone;
    private $instance;
    /* @var $timezone \DateTimeZone */
    private $timezone;
    private $slots; // Array

    //------------------------------------------------------------

    public function getMonth()
    {
        return $this->month;
    }

    public function setMonth($month)
    {
        $this->month = $month; // 'm' 01–12
    }

    //------------------------------------------------------------

    public function getYear()
    {
        return $this->year;
    }

    public function setYear($year)
    {
        $this->year = $year; // 'Y'
    }

    //------------------------------------------------------------

    public function getDay()
    {
        return $this->day;
    }

    public function setDay($day)
    {
        $this->day = $day; // 'd' 01–31
    }

    //------------------------------------------------------------

    public function getServiceIds()
    {
        return $this->service_ids;
    }

    public function setServiceIds(array $service_ids)
    {
        $this->service_ids = $service_ids;
    }

    //------------------------------------------------------------

    public function getRequestedServiceIds()
    {
        return $this->requested_service_ids;
    }

    public function setRequestedServiceIds(array $service_ids)
    {
        $this->requested_service_ids = $service_ids;
    }

    //------------------------------------------------------------

    public function getRequestedCoworkerIds()
    {
        return $this->requested_coworker_ids;
    }

    public function setRequestedCoworkerIds(array $coworker_ids)
    {
        $this->requested_coworker_ids = $coworker_ids;
    }

    //------------------------------------------------------------

    public function getCoworkerIds()
    {
        return $this->coworker_ids;
    }

    public function setCoworkerIds(array $coworker_ids)
    {
        $this->coworker_ids = $coworker_ids;
    }

    //------------------------------------------------------------

    /**
     * @return \DateTimeZone
     */
    public function getTimezone()
    {
        return new \DateTimeZone($this->timezone);
    }

    public function setTimezone(\DateTimeZone $timezone_obj)
    {
        $this->timezone = $timezone_obj->getName();
    }

    //------------------------------------------------------------

    public function setIsWidgetYes()
    {
        $this->is_widget = TRUE;
    }

    public function setIsWidgetNo()
    {
        $this->is_widget = FALSE;
    }

    public function getIsWidget()
    {
        return $this->is_widget;
    }

    //------------------------------------------------------------

    public function setIsAjaxCallYes()
    {
        $this->is_ajax_call = TRUE;
    }

    public function setIsAjaxCallNo()
    {
        $this->is_ajax_call = FALSE;
    }

    public function getIsAjaxCall()
    {
        return $this->is_ajax_call;
    }

    //------------------------------------------------------------

    public function setNoFilter($bool)
    {
        $this->no_filter = (bool)$bool;
    }

    public function getNoFilter()
    {
        return $this->no_filter;
    }

    //------------------------------------------------------------

    public function setNoTimezone($bool)
    {
        $this->no_timezone = (bool)$bool;
    }

    public function getNoTimezone()
    {
        return $this->no_timezone;
    }

    //------------------------------------------------------------

    public function getInstance()
    {
        return $this->instance;
    }

    public function setInstance($instance)
    {
        $this->instance = $instance;
    }

    //------------------------------------------------------------

    public function getSlots()
    {
        if (!empty($this->slots)) {
            return $this->slots;
        } else {
            return array();
        }
    }

    public function setSlots($slots)
    {
        $this->slots = $slots;
    }

    //------------------------------------------------------------

    /**
     * @param null $data
     *
     * @return string
     */
    public function encode($data = NULL)
    {
        if (is_null($data)) {
            return base64_encode(gzdeflate(serialize($this)));
        } else {
            return base64_encode(gzdeflate(serialize($data)));
        }
    }

    /**
     * @param string $encoded
     *
     * @return RenderParameters
     */
    public function decode($encoded)
    {
        return unserialize(gzinflate(base64_decode($encoded)));
    }

}
