<?php
/**
 * Template Name: About Layout
 *
 * Description: A page template that provides a key component of WordPress as a CMS
 * by meeting the need for a carefully crafted introductory page. The front page template
 * in Twenty Twelve consists of a page content area for adding text, images, video --
 * anything you'd like -- followed by front-page-only widgets in one or two columns.
 *
 * @package WordPress
 * @subpackage Twenty_Twelve
 * @since Twenty Twelve 1.0
 */

get_header(); ?>


<div class="aboutUsSection">
    
    
<div class="col2 left">

    <h3><em>About</em>Kylie Day</h3>
    
<?php

// checks if there are any posts that match the query
if (have_posts()) :

  // If there are posts matching the query then start the loop
  while ( have_posts() ) : the_post();

    // the code between the while loop will be repeated for each post
    ?>

    <?php the_content(); ?>
    
    <?php

    // Stop the loop when all posts are displayed
 endwhile;

// If no posts were found
else :
?>
<p>Sorry no posts matched your criteria.</p>
<?php
endif;
?>
    
    
</div>
    
<div class="right col2">
    
    <img src="<?php bloginfo('template_directory'); ?>/images/kylieDay.jpg" alt="" />
    
</div>    
    

    <div class="clearFix"></div>
    
    
<div class="aboutCompany clearFix">
    <div class="borderDotted">
    
    <h3><em>About</em>Cook Lab</h3>
        <img src="<?php bloginfo('template_directory'); ?>/images/sep1.png" alt="" />
    <p>Through easy to understand, hands-on cooking classes, Cook Lab will help you discover exciting new worlds from molecular gastronomy to wholefood nutrition and everything in between. Take a journey into the science of food and learn how to prepare food and cook at a molecular level. It is sure to change the way you see these everyday tasks, making it an adventure with limitless possibilities for flavour, texture and your health.</p>
    
    <p><a href="http://cooklab.com.au/cooking-classes/">Read full class descriptions to learn more about Cook Lab cooking classes</a></p>
        
    </div>
</div>    
    
    
    
    
    
    
</div> 



<?php get_footer(); ?>