<?php
/**
 * Template Name: Cooking Classes Template
 *
 * Description: A page template that provides a key component of WordPress as a CMS
 * by meeting the need for a carefully crafted introductory page. The front page template
 * in Twenty Twelve consists of a page content area for adding text, images, video --
 * anything you'd like -- followed by front-page-only widgets in one or two columns.
 *
 * @package WordPress
 * @subpackage Twenty_Twelve
 * @since Twenty Twelve 1.0
 */

get_header(); ?>



<div class="bookCookingClasses inner clearFix">
    

    <h3><em>Book</em>Cooking Classes</h3>
    
    <p>Cook Lab classes are taking cooking and nutrition to the next level. Learn the science behind the ways you prepare and cook, making your food not only taste amazing but be better for you.</p>
    
    
    <ul class="classList">
        <li>
            <img src="<?php bloginfo('template_directory'); ?>/images/cooking1.jpg" alt="" /> 
            <h4>Molecular Gastronomy</h4>
            <a class="btn book" href="http://cooklab.com.au/molecular-gastronomy/">Book Online</a>
        </li>
        
        <li>
            <img src="<?php bloginfo('template_directory'); ?>/images/cooking2.jpg" alt="" /> 
            <h4>Science of Flavour</h4>
            <a class="btn book" href="http://cooklab.com.au/science-of-flavour/">Book Online</a>
        </li>

        <li>
            <img src="<?php bloginfo('template_directory'); ?>/images/cooking3.jpg" alt="" /> 
            <h4>Nutrition Science</h4>
            <a class="btn book" href="http://cooklab.com.au/nutrition-science/">Book Online</a>
        </li>
        
        <li>
            <img src="<?php bloginfo('template_directory'); ?>/images/cooking4.jpg" alt="" /> 
            <h4>Private and Corporate Groups</h4>
            <a class="btn book" href="http://cooklab.com.au/corporate-group-entry-form/">Enquire Now</a>
        </li>
    </ul>
    
</div>  

    <div class="purchaseGift inner">
    
        <h3><em>Purchase</em>Gift Vouchers</h3>

        <a href="https://cooklab.com.au/product/gift-voucher/" class="btn lineBtn">Buy Online</a>

<!--        <a href="javascript:void(null)" class="btn lineBtn enq">Enquire Now</a> -->
        
        
        
        <div class="buyVoucher width" style="display:none;">
        <?php // echo do_shortcode("[contact-form-7 id='109' title='Gift Voucher']"); ?>
            
        <?php echo do_shortcode("[tb-calendar nofilter='yes' notimezone='yes' booking='giftvoucher']"); ?>            
            
        </div>
    
    </div>


<?php get_footer(); ?>