<?php
/**
 * Template Name: Front Page Template
 *
 * Description: A page template that provides a key component of WordPress as a CMS
 * by meeting the need for a carefully crafted introductory page. The front page template
 * in Twenty Twelve consists of a page content area for adding text, images, video --
 * anything you'd like -- followed by front-page-only widgets in one or two columns.
 *
 * @package WordPress
 * @subpackage Twenty_Twelve
 * @since Twenty Twelve 1.0
 */

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>

<head profile="http://gmpg.org/xfn/11">
<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>" />

<title><?php wp_title('&laquo;', true, 'right'); ?></title>

<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />

    
    
    
    
<link rel="apple-touch-icon" sizes="57x57" href="/apple-icon-57x57.png">
<link rel="apple-touch-icon" sizes="60x60" href="/apple-icon-60x60.png">
<link rel="apple-touch-icon" sizes="72x72" href="/apple-icon-72x72.png">
<link rel="apple-touch-icon" sizes="76x76" href="/apple-icon-76x76.png">
<link rel="apple-touch-icon" sizes="114x114" href="/apple-icon-114x114.png">
<link rel="apple-touch-icon" sizes="120x120" href="/apple-icon-120x120.png">
<link rel="apple-touch-icon" sizes="144x144" href="/apple-icon-144x144.png">
<link rel="apple-touch-icon" sizes="152x152" href="/apple-icon-152x152.png">
<link rel="apple-touch-icon" sizes="180x180" href="/apple-icon-180x180.png">
<link rel="icon" type="image/png" sizes="192x192"  href="/android-icon-192x192.png">
<link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="96x96" href="/favicon-96x96.png">
<link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
<link rel="manifest" href="/manifest.json">
<meta name="msapplication-TileColor" content="#ffffff">
<meta name="msapplication-TileImage" content="/ms-icon-144x144.png">
<meta name="theme-color" content="#ffffff">    
    
    
    
    
    
    
    
<link href="https://fonts.googleapis.com/css?family=Mr+De+Haviland|Open+Sans:300,300i,400,400i,600,600i,700,700i,800,800i|PT+Serif:400,400i,700,700i" rel="stylesheet">    
    
<meta name="viewport" content="width=device-width">

<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>


<div class="container">
        <header>
            <div class="logo"><a href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php bloginfo('template_directory'); ?>/images/logo.png" alt=""></a></div>
            
            <span class="toggleMenu">Menu</span>
            <?php
                wp_nav_menu( array(
                    'theme_location' => 'primaryNav5',
                    'menu_class'     => 'menu',
                 ) );
            ?>
        </header>
    
    <div class="slides">
        <div class="slideText clearFix">
            <h3><em>What's</em>CookLab</h3>
            <span class="sepIcon"> </span>
            <p>Cook Lab classes are taking cooking and nutrition to the next level. Learn the science behind the ways you prepare and cook, making your food not only taste amazing but be better for you.</p>            
        </div>
            <a class="learnMore btn" href="http://cooklab.com.au/about/">Learn More</a>
    </div>
    
    
    <div class="section2 clearFix">
        <div class="left col2">
            <h3><em>Enroll</em>Cooking Classes</h3>
            <p>Click here to find out more about our upcoming classes and prices. Book a class online or purchase a gift certificate to give a unique experience to the passionate foodie in your life.</p>
            
            <a class="btn" href="http://cooklab.com.au/cooking-classes/">Book Online</a>
        </div>
        
        <div class="right col2 brder">
            <img src="<?php bloginfo('template_directory'); ?>/images/img1.jpg" alt="" />
        </div>
    </div>
    
    
    
    <div class="section3 clearFix">
        <div class="width">
        <div class="textHolder left col2">
            <div class="brdr">
            <span><img src="<?php bloginfo('template_directory'); ?>/images/user.jpg" alt="" class="userPic" /></span>
            <h4>Kylie Day</h4>
            <p>Meet Cook Lab's founder and chief food nerd, Kylie Day. Having spent her whole life in the food world as a chef asking too many questions without enough answers, she became a food scientist to find them. Kylie now dedicates her time to sharing her knowledge with others and when she's not running one of our amazing cooking classes you can find her in the kitchen, looking for answers to questions that might have you asking 'why'?</p>
            </div>
        </div>
            </div>
    </div>
    
    
    
    <div class="section4 clearFix">
        <h3><em>Learn</em>Food Science</h3>
        <p>Explore the science of cooking, nutrition and molecular gastronomy via Cook Lab’s dedicated learning channels below.</p>
        
        
        <ul class="width">
            <li><a href="http://cooklab.com.au/category/cooking/"><img src="<?php bloginfo('template_directory'); ?>/images/imga.jpg" alt="" /></a><h4>Cooking</h4></li>            
            <li><a href="http://cooklab.com.au/category/nutrition/"><img src="<?php bloginfo('template_directory'); ?>/images/imgb.jpg" alt="" /></a><h4>Nutrition</h4></li>
            <li><a href="http://cooklab.com.au/category/moleculargastronomy/"><img src="<?php bloginfo('template_directory'); ?>/images/imgc.jpg" alt="" /></a><h4>Molecular Gastronomy</h4></li>
        </ul>
        
    </div>    
    
    
<?php get_footer(); ?>